/* 

	CConnection.h
	
	CommToolbox connection class.
	
	SUPERCLASS = CBureaucrat.
	
	Copyright  1992-93 Romain Vignes. All rights reserved.
	
 */

#define _H_CConnection


#include <CBureaucrat.h>				/* Interface for its superclass */

#include <Connections.h>				/* Apple includes */


/* Connection specific commands */

#define cmdConnChoose	2100			/* Connection setup */
#define cmdConnOpen		2101			/* Connection opening */
#define cmdConnClose	2102			/* Connection closing */
#define cmdConnReset	2103			/* Connection reset */
#define cmdConnBreak	2104			/* BREAK signal sending */
#define cmdConnListen	2105			/* Connection listening */


/* Broadcast indications */

enum	{
	connOpenInd = 2101,
	connCloseInd
};


/* Forward Declarations */

class CCluster;


/* Class definition */

class CConnection : public CBureaucrat	{

protected:

	/* Class Variables */
	
	static CCluster	*cConnList;

	/* Instance Variables */

	ConnHandle		itsConn;
	Boolean			connOpen;
	
	virtual OSErr	getStatus(CMBufferSizes *sizes,CMStatFlags *flags);
	
public:

	/* Instance Variables */

	Boolean			active;
	
	/* Class Methods */
	
	static Boolean	cIsConnectionCmd(long theCmd);
	static OSErr	cCheckToolName(Str31 toolName);
	static void		cConnIdle(void);
	static void		cInitManager(void);
	static short	cGetCMVersion(void);


	/* Instance Methods */
	
	void			IConnection(CBureaucrat *aSupervisor,Str31 toolName,
						CMRecFlags flags,CMBufferSizes desiredSizes,
						long refcon, long userData);
	virtual void	Dispose(void);
	virtual void	UpdateMenus(void);
	virtual void	DoCommand(long theCommand);
	virtual void	ConnectionChoose(void);
	virtual short	SetConfig(char *theConfig);
	virtual Ptr		GetConfig(void);
	virtual void	OpenConnection(Boolean async,ProcPtr completor,long timeOut);
	virtual void	ListenConnection(Boolean async,ProcPtr completor,long timeOut);
	virtual void	CloseConnection(Boolean async,ProcPtr completor,long timeOut,
						Boolean now);
	virtual Boolean	IsOpen(void);
	virtual long	DataAvail(void);
	virtual OSErr	DataRead(Ptr inBuffer,long *buffSize,Boolean async,
						ProcPtr completor,long timeOut,CMFlags *flags);
	virtual void	DoIdle(void);
	virtual OSErr	DataWrite(Ptr inBuffer,long *buffSize,Boolean async,
						ProcPtr completor,long timeOut,CMFlags flags);
	virtual void	Activate(void);
	virtual void	Deactivate(void);
	virtual void	Reset(void);
	virtual void	SendBreak(void);
	virtual OSErr	GetEnvirons(ConnEnvironRecPtr theEnvirons);
	virtual void	GetToolName(Str31 toolName);

};


/*  */
