/* 

	CFileTransfer.h
	
	CommToolbox file transfer class.
	
	SUPERCLASS = CBureaucrat.
	
	Copyright  1992-93 Romain Vignes. All rights reserved.
	
 */

#define _H_CFileTransfer

#include <FileTransfers.h>					/* Apple includes */

#include <CBureaucrat.h>					/* Interface for its superclass */


/* Commands */

#define cmdFTransChoose		2300			/* Transfer setup */
#define cmdFTransSend		2301			/* File sending */
#define cmdFTransRecv		2302			/* File receiving */


/* Forward Declarations */

class CCluster;


/* class definition */

class CFileTransfer : public CBureaucrat	{

protected:

	/* Class Variables */
	
	static CCluster	*cFTransList;
	
	/* Instance Variables */

	FTHandle		itsFTrans;
	Boolean			wasFTMode;
	
public:

	/* Instance Variables */

	Boolean			active;

	/* Class Methods */
	
	static void		cInitManager(void);
	static short	cGetFTVersion(void);
	static OSErr	cCheckToolName(Str31 toolName);
	static Boolean	cIsFileTransferCmd(long theCmd);
	static void		cFTransIdle(void);
	static Boolean	cTestToolMenu(short theMenu, short theItem);
	static Boolean	cTestToolEvent(EventRecord *macEvent, WindowPtr theWindow);
	
	/* Instance Methods */
	
	void			IFileTransfer(CBureaucrat *aSupervisor,Str31 toolName,
						FTFlags flags,ProcPtr sendProc,ProcPtr recvProc,
						ProcPtr readProc,ProcPtr writeProc,ProcPtr environsProc,
						WindowPtr owner,long refcon, long userData);
	virtual void	Dispose(void);
	virtual void	UpdateMenus(void);
	virtual void	DoCommand(long theCommand);
	virtual void	FileTransferChoose(void);
	virtual short	SetConfig(char *theConfig);
	virtual void	GetToolName(Str31 toolName);
	virtual Ptr		GetConfig(void);
	virtual void	DoIdle(void);
	virtual void	Activate(void);
	virtual void	Deactivate(void);
	virtual Boolean	IsRunning(void);
	virtual void	Start(FTDirection direction);
	virtual Boolean	DoEvent(EventRecord *theEvent,WindowPtr theWindow);
	virtual Boolean	Success(void);
	virtual Boolean	DoMenu(short theMenu,short theItem);
};


/*  */
